<script lang="ts">
import Vue from 'vue';
import { SearchInput } from '~/components/common/index.vue';
import SearchBox from './search-box.vue';

export default Vue.extend({
  name: 'JobsHero',
  components: {
    SearchInput,
    SearchBox,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      greenhouseData: [],
      searchParam: '',
    };
  },
  computed: {
    searchGreenhouseListings() {
      if (
        !this.greenhouseData ||
        this.greenhouseData.length === 0 ||
        this.searchParam.length === 0
      ) {
        return [];
      }

      return this.greenhouseData.flatMap((department) =>
        department.jobs.filter(
          (job) =>
            job.title.toLowerCase().includes(this.searchParam.toLowerCase()) ||
            job.location.name
              .toLowerCase()
              .includes(this.searchParam.toLowerCase()),
        ),
      );
    },
  },
  watch: {
    '$store.state.greenhouseApiData.departments': {
      handler(newValue) {
        this.greenhouseData = newValue || [];
      },
      immediate: true,
    },
  },
  created() {
    this.checkGreenhouseData();
  },
  methods: {
    handleSearchValue(value) {
      this.searchParam = value || '';
    },
    checkGreenhouseData() {
      this.greenhouseData =
        this.$store.state.greenhouseApiData?.departments || [];
    },
  },
});
</script>

<template>
  <section class="hero">
    <SlpContainer>
      <SlpTypography
        tag="h1"
        variant="heading1-bold"
        class="slp-mb-24 slp-mt-24"
      >
        {{ data.title }}</SlpTypography
      >
      <SlpTypography tag="p" variant="heading5" class="slp-mb-24">
        {{ data.subheader }}
      </SlpTypography>
      <SearchInput
        placeholder="Search by job title or keyword"
        type="internal-search"
        @searchValue="handleSearchValue"
      />
      <SearchBox :search-results="searchGreenhouseListings" />
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.hero {
  padding: $spacing-96 0;
  background: linear-gradient(
    90deg,
    #eee7fd 2.53%,
    rgba(246, 243, 254, 0.83) 50.98%,
    rgba(255, 212, 216, 0.45) 100%
  );

  @media (max-width: $breakpoint-md) {
    background: linear-gradient(
      90deg,
      #eee7fd 2.53%,
      rgba(246, 243, 254, 0.83) 50.98%,
      rgba(255, 212, 216, 0.45) 100%
    );
  }
}
</style>
